#
# $Id: PNLBase.py 13 2004-08-19 14:32:19Z zope $
#

"""Basic services for most content classes"""

__version__ = "$Revision: 13 $" [11:-2]

# Zope core import
from Globals import InitializeClass
from AccessControl import Permissions, getSecurityManager, ClassSecurityInfo, Unauthorized

# CMF/Plone imports
from Products.CMFCore.utils import getToolByName


class PNLContentBase:
    """Shared by all that's in a NewsletterCentral
    """
    security = ClassSecurityInfo()

    security.declarePublic('getTheme')
    def getTheme(self):
        """Returns the NewsletterTheme parent object or None"""

        obj = self
        while 1:
            obj = obj.aq_parent
            if obj.meta_type == 'NewsletterTheme':
                return obj
            if not obj:
                return None
        return
    
    security.declarePublic('ploneCharset')
    def ploneCharset(self):
        """The default charset of this Plone instance"""

        portal_properties = getToolByName(self, 'portal_properties')
        charset = portal_properties.site_properties.getProperty('default_charset').strip()
        return charset

InitializeClass(PNLContentBase)
