#
# $Id: PNLUtils.py 82 2005-11-07 13:47:32Z zope $
#

"""Misc utilities"""

import re

try:
    dummy = True
except NameError, e:
    True = 1
    False = 0

_mailAddrRx = re.compile(r"^([0-9a-zA-Z_&.+-]+!)*[0-9a-zA-Z_&.+-]"
                         r"+@(([0-9a-zA-Z]([0-9a-zA-Z-]*[0-9a-zA-Z])?\.)"
                         r"+[a-zA-Z]{2,4}|([0-9]{1,3}\.){3}[0-9]{1,3})$")

def checkMailAddress(someAddr):
    """Checks the validity of a mail address"""

    global _mailAddrRx
    return _mailAddrRx.match(someAddr.strip()) != None

# Shell command that runs Lynx. "lynx" may be enough in most Unix systems.
# Zope/Windows users may use something like "C:\\Program Files\\lynx\\lynx.exe" or "C:\\Progra~1\lynx\lynx.bat"
# depending on their installation.

LYNX_COMMAND = "lynx"

LYNX_OPTIONS = "-nolist -dump"

from AccessControl import SpecialUsers

def ownerOfObject(obj):
    """Provides acl_user acquisition wrapped owner of object"""
    udb, uid = obj.getOwnerTuple()
    root = obj.getPhysicalRoot()
    udb = root.unrestrictedTraverse(udb, None)
    if udb is None:
        user = SpecialUsers.nobody
    else:
        user = udb.getUserById(uid, None)
        if user is None:
            user = SpecialUsers.nobody
        else:
            user = user.__of__(udb)
    return user

def escPercent(text):
    """Replace '%' with '%%' except '%('"""
    pat = re.compile(r'%(?!\()')
    return pat.sub('%%', text)
