#
# $Id: __init__.py 45 2004-12-28 15:09:06Z zope $
#

"""Newsletter Plone"""

__version__ = "$Revision: 45 $" [11:-2]

## Archetypes import
from Products.Archetypes.public import *
from Products.Archetypes import listTypes

## CMF imports

from Products.CMFCore import utils, CMFCorePermissions, DirectoryView
from Products.CMFCore.utils import registerIcon

## App imports

import NewsletterTheme, Newsletter, Subscriber, Section, NewsletterTopic

PROJECTNAME = 'PloneGazette'

product_globals = globals()

DirectoryView.registerDirectory('skins', product_globals)
DirectoryView.registerDirectory('skins/PloneGazette', product_globals)

## Types to register

contentConstructors = (Newsletter.addNewsletter, Subscriber.addSubscriber, NewsletterTopic.addNewsletterTopic)
contentClasses = (Newsletter.Newsletter, Subscriber.Subscriber, NewsletterTopic.NewsletterTopic)
factoryTypes = (Newsletter.Newsletter.factory_type_information,
                Subscriber.Subscriber.factory_type_information,
                NewsletterTopic.NewsletterTopic.factory_type_information)

def initialize(context):

    import NewsletterReference
    import NewsletterBTree
    
    utils.ContentInit(
        'Plone Gazette Newsletter Theme',
        content_types = (NewsletterTheme.NewsletterTheme,),
        permission = PNLPermissions.AddNewsletterTheme,
        extra_constructors = (NewsletterTheme.addNewsletterTheme,),
        fti = NewsletterTheme.NewsletterTheme.factory_type_information).initialize(context)
   
    utils.ContentInit(
        'Plone Gazette Newsletter Section',
        content_types = (Section.Section,),
        permission = PNLPermissions.ChangeNewsletter,
        extra_constructors = (Section.addSection,),
        fti = Section.Section.factory_type_information).initialize(context)
 
    utils.ContentInit(
        'Plone Gazette resources',
        content_types = contentClasses,
        permission = CMFCorePermissions.AddPortalContent,
        extra_constructors = contentConstructors,
        fti = factoryTypes).initialize(context)
    
    registerIcon(NewsletterTheme.NewsletterTheme, 'skins/PloneGazette/NewsletterTheme.gif', globals())
    registerIcon(Newsletter.Newsletter, 'skins/PloneGazette/Newsletter.gif', globals())
    registerIcon(Subscriber.Subscriber, 'skins/PloneGazette/Subscriber.gif', globals())
    registerIcon(Section.Section, 'skins/PloneGazette/Section.gif', globals())
    registerIcon(NewsletterTopic.NewsletterTopic, 'skins/PloneGazette/NewsletterTopic.gif', globals())

    # Archetypes init
    content_types, constructors, ftis = process_types(listTypes(PROJECTNAME), PROJECTNAME)

    utils.ContentInit(
        PROJECTNAME + ' Content',
        content_types = content_types,
        permission = CMFCorePermissions.AddPortalContent,
        extra_constructors = constructors,
        fti = ftis,).initialize(context)
    
    return





